package com.ceb.gjjs.mda.junitTest;

import com.brilliance.jrxx.utils.FastJsonUtil;
import com.ceb.gjjs.mda.service.DbarolService;
import com.ceb.gjjs.mda.service.impl.DbarolServiceImpl;
import com.fasterxml.jackson.annotation.JsonFilter;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.ser.impl.SimpleBeanPropertyFilter;
import com.fasterxml.jackson.databind.ser.impl.SimpleFilterProvider;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.SpringBootConfiguration;
import org.springframework.boot.test.context.SpringBootTest;

@SpringBootTest
@SpringBootConfiguration
public class DbTest {

//    @Autowired
//    DbarolService dbarolService;
//
//    @org.junit.jupiter.api.Test
//    void contextLoads() {
//        System.out.println("userService.master() = " + dbarolService.master());
//        System.out.println("userService.slave() = " + dbarolService.slave());
//    }

    @Test
    public void test() throws JsonProcessingException {
        SimpleFilterProvider filterProvider = new SimpleFilterProvider();
        filterProvider.addFilter("userFilter",   //添加过滤器名称
                SimpleBeanPropertyFilter.serializeAllExcept("username","password")); //这里指定不序列化的属性
/*        Set exclude = new HashSet();
        exclude.add("username");
        exclude.add("password");
        filterProvider.addFilter("userFilter",
                SimpleBeanPropertyFilter.serializeAllExcept(exclude)); //这里指定不序列化的属性也可以放到Set集合里面
        filterProvider.addFilter("userFilter",
                SimpleBeanPropertyFilter.serializeAll());  // serializeAll()序列化所有属性，
        filterProvider.addFilter("userFilter",
                SimpleBeanPropertyFilter.filterOutAllExcept("age")); //只序列化这里包含的属性*/
        ObjectMapper mapper = new ObjectMapper();
        mapper.setFilterProvider(filterProvider);
        User user = new User();
        user.setUsername("小明");
        user.setPassword("123");
        user.setAge(18);
        String s = mapper.writer().withDefaultPrettyPrinter().writeValueAsString(user);
        System.out.println("我是序列化" + s);
        User user1 = mapper.readValue("{\"username\":\"小明\",\"password\":\"123\",\"age\":18}", User.class);
        System.out.println("我是反序列化" + FastJsonUtil.toJSONString(user1));  //这里注意只是在序列化的时候过滤字段，在反序列化的时候是不过滤的
    }
}
